using System;

namespace shobonjtag
{
	/// <summary>
	/// JTAG foCX`F[ڑ邽߂̉zfoCXZieXgj
	///
	/// RXgN^ Q̈ɂꂼ JtagDevice ^ƁA
	/// Q̐΂qzfoCXNX̂悤ɂӂ܂܂B
	///  DeviceChain g悤ɂƁAȂłiEցEj͂B
	///
	/// (cdr) null  DeviceChain ́A
	/// (car)̃foCXĝ悤ɂӂ܂܂B
	/// 
	/// g̗F
	/// QȂĂƂ
	/// JtagDevice jd = new DeviceChain(new xc95144_pq160(),new xc95144_pq160()) ;
	///
	/// RȏȂĂƂ̗i cdr  null  DeviceChainCell łj
	/// JtagDevice jd = new DeviceChain(new xc95144_pq160(),new DeviceChain(new xc95216_pq160(),new xc95216_pq160())) ....
	/// </summary>
	public class DeviceChain : JtagDevice
	{
		JtagDevice car , cdr ;

		public DeviceChain(JtagDevice ca,JtagDevice cd)
		{
			car = ca ;
			cdr = cd ;
		}
		#region JtagDevice o

		public String LSINAME {
			get {
				// OȂł܂
				if (car == null) {
					return null ;
				}
				if (cdr == null) {
					return car.LSINAME ;
				}
				return car.LSINAME + " -> " + cdr.LSINAME ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				// ԏixjmԂ܂
				// 2005.7.1 r̕ύX
				if (car == null) {
					return 0.0 ;
				}
				if (cdr == null) {
					return car.TAP_SCAN_CLOCK ;
				}
				if (car.TAP_SCAN_CLOCK < cdr.TAP_SCAN_CLOCK) {
					return car.TAP_SCAN_CLOCK ;
				}
				return cdr.TAP_SCAN_CLOCK ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				if (car == null) {
					return 1 ;
				}
				if (cdr == null) {
					return car.INSTRUCTION_LENGTH ;
				}
				// Pɑ܂
				return car.INSTRUCTION_LENGTH +  cdr.INSTRUCTION_LENGTH ;
			}
		}

		public System.Collections.Specialized.StringDictionary INSTRUCTION_OPCODE {
			get {
				// {̂܂Ă悤Ȃ̂ŁAcar ̎Ԃ
				return car.INSTRUCTION_OPCODE ;
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				if (car == null) {
					return null ;
				}
				if (cdr == null) {
					return car.INSTRUCTION_CAPTURE ;
				}
				// Pɑ܂
				return car.INSTRUCTION_CAPTURE +  cdr.INSTRUCTION_CAPTURE ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {				
				if (car == null) {
					return 1 ;
				}
				if (cdr == null) {
					return car.BOUNDARY_LENGTH ;
				}
				// Pɑ܂
				return car.BOUNDARY_LENGTH +  cdr.BOUNDARY_LENGTH ;
			}
		}

		public String GetInstruction(String instType) {
			// Pɑ܂îȁj
			// instType ɂȂ 
			// ̃foCX BYPASSiK{jԂ̂悤ȋC邪AB
			if (car == null) {
				return null ;
			}
			if (cdr == null) {
				return car.GetInstruction(instType) ;
			}
			return car.GetInstruction(instType) + cdr.GetInstruction(instType) ;
		}

		public void showViewForm() {
			if (car != null) {
				car.showViewForm() ;
			}
			if (cdr != null) {
				cdr.showViewForm() ;
			}
		}

		public void disposeViewForm() {
			if (car != null) {
				car.disposeViewForm() ;
			}
			if (cdr != null) {
				cdr.disposeViewForm() ;
			}
		}
		
		#endregion

		#region SignalListener o

		public void SendSignal(string signalvector) {
			if (car != null) {
				car.SendSignal(signalvector.Substring(0,car.BOUNDARY_LENGTH)) ;
				if (cdr != null) {
					cdr.SendSignal(signalvector.Substring(car.BOUNDARY_LENGTH,cdr.BOUNDARY_LENGTH)) ;
				}
			} else {
				if (cdr != null) {
					cdr.SendSignal(signalvector.Substring(cdr.BOUNDARY_LENGTH)) ;
				}
			}
		}
		#endregion
	}
}
