using System;
using com.miolab.dotnet.util.serial ;

namespace shobonjtag
{
	/// <summary>
	/// FTDI232BM or 245BM(not tested) BitBang Cable
	/// </summary>
	public class FTDI232Cable : JtagCable
	{
		/// <summary>
		/// BitBang [h̃rbg蓖(245BM)
		/// </summary>
		const int D7     = 0x80 ;
		const int D6     = 0x40 ;
		const int D5     = 0x20 ;
		const int D4     = 0x10 ;
		const int D3     = 0x08 ;
		const int D2     = 0x04 ;
		const int D1     = 0x02 ;
		const int D0     = 0x01 ;

		/// <summary>
		/// 232BM
		/// </summary>
		const int RI     = 0x80 ;
		const int DCD    = 0x40 ;
		const int DSR    = 0x20 ;
		const int DTR    = 0x10 ;
		const int CTS    = 0x08 ;
		const int RTS    = 0x04 ;
		const int RXD    = 0x02 ;
		const int TXD    = 0x01 ;

		/// <summary>
		/// erbg蓖āie삵P[uɂj
		/// </summary>
		const int TDI    = TXD ;
		const int TMS    = DSR ;
		const int TCK    = CTS ;
		const int TDO    = RXD ;

		/// <summary>
		/// o̓|[grbg}XN
		/// </summary>
		const int OUTMASK = (TDI | TMS | TCK) ;

		/// <summary>
		/// gp|[grbg}XN
		/// </summary>
		const int USEMASK = (TDI | TMS | TCK | TDO) ;

		/// <summary>
		/// FTDI232BM or 245BM(not tested) BitBang Cable
		/// </summary>
		public FTDI232 ft ;

		/// <summary>
		/// Ԗڂ̃foCXgp邩H
		/// </summary>
		const int DEVNO = 0 ;

		/// <summary>
		/// ʐMx(*16? ɂȂ炵)
		/// FTDI  AvP[Vm[giAN232B-01jQ
		/// </summary>
		const int BAUD = 9600 ;

		/// <summary>
		/// Õrbg
		/// </summary>
		public int OUTBITS = 0x00 ;

		/// <summary>
		/// ڑĂ鉽Ԗڂ̃P[u
		/// </summary>
		public int devno = 0 ;

		public FTDI232Cable(int deviceno)
		{
			devno = deviceno ;
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}
		#region JtagCable o

		public int Open() {
			// TODO:  FTDI232Cable.Open ǉ܂B
			try {
				if (FTDI232.GetNumDevices() > devno) {
					ft = new FTDI232() ;

					// x̐ݒ
					ft.Open(devno,BAUD) ;

					// CeV^C}̐ݒ
					ft.SetLatencyTimer(100) ;

					// BitBang Mode
					ft.SetBitMode(OUTMASK,1) ;

					// o͂̃NA
					ft.Send((sbyte)OUTBITS) ;
					return 0 ;
				}
			} catch(System.DllNotFoundException) {
				return -2 ; // FT2xx.dll Ȃ	
			}
			return -1; // foCXos\
		}

		public void Close() {
			// TODO:  FTDI232Cable.Close ǉ܂B
			if (ft != null) {
				// BitBang Mode Off
				ft.SetBitMode(OUTMASK,0) ;
				ft.Close() ;
			}
		}

		public void Tcklow() {
			// TODO:  FTDI232Cable.Tcklow ǉ܂B
			OUTBITS &= (~TCK) ;
			// ǂݎ
			while(ft.Receive() != null) {
				//  TDO ǂݎ̂߁AReadPipe ̋ǂ݁BpCvl܂Ăƒx݂B
			}
			ft.Send((sbyte)OUTBITS) ;
		}

		public void Tckhigh() {
			// TODO:  FTDI232Cable.Tckhigh ǉ܂B
			OUTBITS |= TCK ;
			ft.Send((sbyte)OUTBITS) ;
		}

		public void Tdiout(int tms, int tdi) {
			// TODO:  FTDI232Cable.Tdiout ǉ܂B
			OUTBITS &= (~(TMS | TDI)) ;
			OUTBITS |= ((tms * TMS) | (tdi * TDI)) ;
			ft.Send((sbyte)OUTBITS) ;
		}

		public int Tdoread() {
			// TODO:  FTDI232Cable.Tdoread ǉ܂B
			int b = ft.GetBitMode() ; // & USEMASK ;
			return ((b & TDO) != 0) ? 1 : 0 ;
		}

		#endregion
	}
}
